<template>
  <div>
    <SidebarRegister />
    <div class="container-register">
      <div class="icon-step">
        <svg
          xmlns="http://www.w3.org/2000/svg"
          width="26"
          height="26"
          fill="currentColor"
          class="bi bi-person-workspace"
          viewBox="0 0 16 16"
        >
          <path
            d="M4 16s-1 0-1-1 1-4 5-4 5 3 5 4-1 1-1 1H4Zm4-5.95a2.5 2.5 0 1 0 0-5 2.5 2.5 0 0 0 0 5Z"
          />
          <path
            d="M2 1a2 2 0 0 0-2 2v9.5A1.5 1.5 0 0 0 1.5 14h.653a5.373 5.373 0 0 1 1.066-2H1V3a1 1 0 0 1 1-1h12a1 1 0 0 1 1 1v9h-2.219c.554.654.89 1.373 1.066 2h.653a1.5 1.5 0 0 0 1.5-1.5V3a2 2 0 0 0-2-2H2Z"
          />
        </svg>
      </div>
      <h3 class="mt-4 fw-bold">Informasi Pekerjaan</h3>
      <form class="mt-4" @submit.prevent>
        <div class="row">
          <div class="col-6">
            <div class="mb-3">
              <label for="kantorCabang" class="form-label">Kantor Cabang</label>
              <select
                class="form-select"
                aria-label="Default select example"
                id="kantorCabang"
                v-model="form.idBranch"
                required
              >
                <option value="" selected>Pilih kantor cabang...</option>
                <option
                  :value="branch.idBranch + '-' + branch.nameBranch"
                  v-for="branch in brancies"
                  :key="branch.idBranch"
                >
                  {{ branch.nameBranch }}
                </option>
              </select>
            </div>
            <div class="mb-3">
              <label for="program" class="form-label">Program</label>
              <select
                class="form-select"
                aria-label="Default select example"
                id="program"
                required
                v-model="form.idProgram"
              >
                <option value="" selected>Pilih program...</option>
                <option
                  :value="program.idProgram + '-' + program.nameProgram"
                  v-for="program in programs"
                  :key="program.idProgram"
                >
                  {{ program.nameProgram }}
                </option>
              </select>
            </div>
            <div class="mb-3">
              <label for="periodePembayaran" class="form-label"
                >Periode Pembayaran</label
              >
              <select
                class="form-select"
                aria-label="Default select example"
                id="periodePembayaran"
                v-model="form.idPaymentPeriod"
                required
              >
                <option value="" selected>Pilih periode pembayaran...</option>
                <option
                  :value="paymentPeriod.idPaymentPeriod + '-' + paymentPeriod.typePaymentPeriod"
                  v-for="paymentPeriod in paymentPeriods"
                  :key="paymentPeriod.idPaymentPeriod"
                >
                  {{ paymentPeriod.typePaymentPeriod }} bulan
                </option>
              </select>
            </div>
            <div class="d-flex my-4 justify-content-end gap-2">
              <button type="button" class="btn btn-secondary" @click="back">
                Kembali
              </button>
              <button type="submit" class="btn btn-primary" @click="save">
                Selanjutnya
              </button>
            </div>
          </div>
        </div>
      </form>
    </div>
  </div>
</template>

<script>
import SidebarRegister from "@/components/SidebarRegister.vue";
import axios from "axios";

export default {
  name: "RegisterStep32View",
  components: {
    SidebarRegister,
  },
  data() {
    return {
      form: {},
      programs: [],
      brancies: [],
      paymentPeriods: [],
      localJob: {},
      localProgram: {},
    };
  },
  methods: {
    setData() {
      if (!this.form.idBranch) {
        this.form.idBranch = "";
      }
      if (!this.form.idProgram) {
        this.form.idProgram = "";
      }
      if (!this.form.idPaymentPeriod) {
        this.form.idPaymentPeriod = "";
      }
    },
    back() {
      this.$router.push({ path: "/register/step-3-1" });
    },
    save() {
      if (this.form.idBranch && this.form.idProgram && this.form.idPaymentPeriod) {
        localStorage.setItem("program", JSON.stringify(this.form));
        this.$router.push({ path: "/register/step-3-3" });
      }
    },
    getBrancies() {
      axios
        .get("http://localhost:3000/branch/view/" + this.localJob.idProvince)
        .then((response) => {
          this.brancies = response.data.data;
        })
        .catch((error) => {
          console.log(error);
        });
    },
    getPrograms() {
      axios
        .get("http://localhost:3000/program/view")
        .then((response) => {
          this.programs = response.data.data;
        })
        .catch((error) => {
          console.log(error);
        });
    },
    getPaymentPeriods() {
      axios
        .get("http://localhost:3000/period/view")
        .then((response) => {
          this.paymentPeriods = response.data.data;
        })
        .catch((error) => {
          console.log(error);
        });
    },
  },
  mounted() {
    this.localJob = JSON.parse(localStorage.getItem("job")) || null;
    if (!this.localJob) {
      this.$router.push({ path: "/register/step-3-1" });
      return;
    }

    this.localProgram = JSON.parse(localStorage.getItem("program")) || null;
    this.form = { ...this.form, ...this.localProgram };

    this.getBrancies();
    this.getPrograms();
    this.getPaymentPeriods();
    this.setData();
  },
};
</script>

<style>
</style>